;; Eksempel på Elisp-kode.

;; Funksjonen GREP-BUFFER (nederst) kan brukes til å etterligne `grep'
;; på et buffer.  Kjøres med `M-x grep-buffer'.

(defun grep-next-match (re)
  (search-forward-regexp re nil t))
    
(defun grep-extract-line ()
  (move-beginning-of-line nil)
  (let ((start (point)))
    (move-end-of-line nil)
    (buffer-substring start (point))))

(defun grep-show-result (lines)
  (let ((rbuf (get-buffer-create "*grep*")))
    (save-excursion
      (set-buffer rbuf)
      (delete-region (point-min) (point-max))
      (dolist (line lines)
	(insert line "\n")))
    (switch-to-buffer-other-window rbuf)))

(defun grep-buffer (re)
  (interactive "sGrep: ")
  (save-excursion
    (beginning-of-buffer)
    (let ((lines (list)))
      (while (grep-next-match re)
	(push (grep-extract-line) lines))
      (grep-show-result (nreverse lines)))))
